"use strict";
this.name = "pirate_cove_conditions";
this.author = "phkb";
this.copyright = "2023 phkb";
this.license = "CC BY-NC-SA 4.0";

//-------------------------------------------------------------------------------------------------------------
this.allowSpawnShip = function(shipkey) {
    var typ = "";
    switch (shipkey) {
        case "pirate-cove":
            typ = "neutral";
            break;
        case "pirate-cove-chaotic":
            typ = "chaotic";
            break;
        case "pirate-cove-pirate":
            typ = "pirate";
            break;
        default:
            return false;
    }
    var pc = worldScripts.Pirate_Coves;
    if (!pc._spawning[typ].replace) return false;
    var chance = pc._spawning[typ].chance;
    // if the following returns true, it will be true for a whole month
    // so if you jump back into the system inside of a month, the same RH should be switched to a pirate cove
    if (system.scrambledPseudoRandomNumber((clock.daysComponent / 30) % 12 + this.$rockHermitSeedVariation(typ)) < chance) return true;
    return false;
}

//----------------------------------------------------------------------------------------
// get a different seed value for each type, so they will be checked independently of each other
this.$rockHermitSeedVariation = function(typ) {
    switch (typ) {
        case "neutral": return system.countShipsWithRole("rockhermit");
        case "chaotic": return system.countShipsWithRole("rockhermit-chaotic") + 10;
        case "pirate": return system.countShipsWithRole("rockhermit-pirate") + 20;
    }
    return 0;
}
