"use strict";
this.name = "Pirate Cove Rock";
this.author = "eric walch";
this.description = "Script for the Pirate_Cove Rock by Lazy Gun";
this.version = "1.5";

this.defenderCount = worldScripts["Pirate_Coves"].basicDefenders + Math.floor(Math.random() * 3);  // defenderCount is redefined by the main script.

//-------------------------------------------------------------------------------------------------------------
this.shipSpawned = function () {
    if (this.ship.dataKey !== "pirate-cove-single") log(this.name, "pirate cove replacing rock hermit for role " + this.ship.primaryRole);
    //this.ship.primaryRole = "pirate-cove"; // needed to set the market correct. << not needed now
    this.maxAirbornDefenders = 3 + Math.floor(Math.random() * 4);
    if (player.score > 512) this.maxAirbornDefenders++;
    if (player.score > 6400) this.maxAirbornDefenders++;
}

//-------------------------------------------------------------------------------------------------------------
// Correct clean hits.
this.shipBeingAttacked = function (attacker) {
    if (attacker && attacker.owner === this.ship && attacker.target === this.ship) {
        attacker.reactToAIMessage("TARGET_LOST");
        log(this.name, "Pirate cove was friendly hit by: " + attacker.displayName);
    }
}

//-------------------------------------------------------------------------------------------------------------
this.stationLaunchedShip = function (ship) {
    if (ship.primaryRole === "defense_ship") ship.switchAI("pirateCovePirateAI.plist");
    if (ship.primaryRole === "scavenger" && !ship.bounty) ship.bounty = 5 + Math.random() * 25;
    if (ship.primaryRole === "escort" && !ship.bounty) ship.bounty = 5 + Math.random() * 15;
}

//-------------------------------------------------------------------------------------------------------------
this.otherShipDocked = function (ship) {
    if (ship.isPlayer) {
        // we are spotted!
        this.ship.displayName.replace("Rock Hermit", "Pirate Cove"); 
    }
    if (ship.primaryRole == "pirate") this.defenderCount++;
}

//-------------------------------------------------------------------------------------------------------------
/*
In addition to the below launched pirates, the AI can also launch pirates as defense ships
when directly attacked.
*/
this.$launchDefender = function () {
    if (this.defenderCount > 0 && this.ship.target
        && this.ship.position.distanceTo(this.ship.target.position) < 15000
        && this.ship.group.count < this.maxAirbornDefenders) {
        var defender = this.ship.launchShipWithRole("pirate");
        if (defender) {
            defender.switchAI("pirateCovePirateAI.plist");
            defender.target = this.ship.target;
            this.ship.group.addShip(defender);
            defender.group = this.ship.group;
            if (!this.ship.bounty && this.ship.target.isPlayer) {
                this.ship.bounty = (this.ship.scanClass == "CLASS_NEUTRAL") ? 100 : 1000; // the cove is no longer clean now.
            }
            this.defenderCount--;
        }
    }
};

//-------------------------------------------------------------------------------------------------------------
this.shipDied = function () {
    // store the time of death
    worldScripts.Pirate_Coves.pirateCoveSystems[system.ID] = clock.days;
};